<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEAttivita ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfEAttivita
 * @subpackage Arrays
 */
class ArrayOfEAttivita extends AbstractStructArrayBase
{
    /**
     * The EAttivita
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\EAttivita[]
     */
    public $EAttivita;
    /**
     * Constructor method for ArrayOfEAttivita
     * @uses ArrayOfEAttivita::setEAttivita()
     * @param \StructType\EAttivita[] $eAttivita
     */
    public function __construct(array $eAttivita = array())
    {
        $this
            ->setEAttivita($eAttivita);
    }
    /**
     * Get EAttivita value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\EAttivita[]|null
     */
    public function getEAttivita()
    {
        return isset($this->EAttivita) ? $this->EAttivita : null;
    }
    /**
     * This method is responsible for validating the values passed to the setEAttivita method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEAttivita method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEAttivitaForArrayConstraintsFromSetEAttivita(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfEAttivitaEAttivitaItem) {
            // validation for constraint: itemType
            if (!$arrayOfEAttivitaEAttivitaItem instanceof \StructType\EAttivita) {
                $invalidValues[] = is_object($arrayOfEAttivitaEAttivitaItem) ? get_class($arrayOfEAttivitaEAttivitaItem) : sprintf('%s(%s)', gettype($arrayOfEAttivitaEAttivitaItem), var_export($arrayOfEAttivitaEAttivitaItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The EAttivita property can only contain items of type \StructType\EAttivita, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set EAttivita value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\EAttivita[] $eAttivita
     * @return \ArrayType\ArrayOfEAttivita
     */
    public function setEAttivita(array $eAttivita = array())
    {
        // validation for constraint: array
        if ('' !== ($eAttivitaArrayErrorMessage = self::validateEAttivitaForArrayConstraintsFromSetEAttivita($eAttivita))) {
            throw new \InvalidArgumentException($eAttivitaArrayErrorMessage, __LINE__);
        }
        if (is_null($eAttivita) || (is_array($eAttivita) && empty($eAttivita))) {
            unset($this->EAttivita);
        } else {
            $this->EAttivita = $eAttivita;
        }
        return $this;
    }
    /**
     * Add item to EAttivita value
     * @throws \InvalidArgumentException
     * @param \StructType\EAttivita $item
     * @return \ArrayType\ArrayOfEAttivita
     */
    public function addToEAttivita(\StructType\EAttivita $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EAttivita) {
            throw new \InvalidArgumentException(sprintf('The EAttivita property can only contain items of type \StructType\EAttivita, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->EAttivita[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\EAttivita|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\EAttivita|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\EAttivita|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\EAttivita|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\EAttivita|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string EAttivita
     */
    public function getAttributeName()
    {
        return 'EAttivita';
    }
}
