<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTPartecipante ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfTPartecipante
 * @subpackage Arrays
 */
class ArrayOfTPartecipante extends AbstractStructArrayBase
{
    /**
     * The TPartecipante
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TPartecipante[]
     */
    public $TPartecipante;
    /**
     * Constructor method for ArrayOfTPartecipante
     * @uses ArrayOfTPartecipante::setTPartecipante()
     * @param \StructType\TPartecipante[] $tPartecipante
     */
    public function __construct(array $tPartecipante = array())
    {
        $this
            ->setTPartecipante($tPartecipante);
    }
    /**
     * Get TPartecipante value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TPartecipante[]|null
     */
    public function getTPartecipante()
    {
        return isset($this->TPartecipante) ? $this->TPartecipante : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTPartecipante method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTPartecipante method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTPartecipanteForArrayConstraintsFromSetTPartecipante(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTPartecipanteTPartecipanteItem) {
            // validation for constraint: itemType
            if (!$arrayOfTPartecipanteTPartecipanteItem instanceof \StructType\TPartecipante) {
                $invalidValues[] = is_object($arrayOfTPartecipanteTPartecipanteItem) ? get_class($arrayOfTPartecipanteTPartecipanteItem) : sprintf('%s(%s)', gettype($arrayOfTPartecipanteTPartecipanteItem), var_export($arrayOfTPartecipanteTPartecipanteItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TPartecipante property can only contain items of type \StructType\TPartecipante, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TPartecipante value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TPartecipante[] $tPartecipante
     * @return \ArrayType\ArrayOfTPartecipante
     */
    public function setTPartecipante(array $tPartecipante = array())
    {
        // validation for constraint: array
        if ('' !== ($tPartecipanteArrayErrorMessage = self::validateTPartecipanteForArrayConstraintsFromSetTPartecipante($tPartecipante))) {
            throw new \InvalidArgumentException($tPartecipanteArrayErrorMessage, __LINE__);
        }
        if (is_null($tPartecipante) || (is_array($tPartecipante) && empty($tPartecipante))) {
            unset($this->TPartecipante);
        } else {
            $this->TPartecipante = $tPartecipante;
        }
        return $this;
    }
    /**
     * Add item to TPartecipante value
     * @throws \InvalidArgumentException
     * @param \StructType\TPartecipante $item
     * @return \ArrayType\ArrayOfTPartecipante
     */
    public function addToTPartecipante(\StructType\TPartecipante $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TPartecipante) {
            throw new \InvalidArgumentException(sprintf('The TPartecipante property can only contain items of type \StructType\TPartecipante, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TPartecipante[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TPartecipante|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TPartecipante|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TPartecipante|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TPartecipante|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TPartecipante|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TPartecipante
     */
    public function getAttributeName()
    {
        return 'TPartecipante';
    }
}
