<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Evento StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:Evento
 * @subpackage Structs
 */
class Evento extends AbstractStructBase
{
    /**
     * The Annotazioni
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Annotazioni;
    /**
     * The Attivita
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfEAttivita
     */
    public $Attivita;
    /**
     * The Cancellabile
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $Cancellabile;
    /**
     * The CancellabileOre
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $CancellabileOre;
    /**
     * The Descrizione
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Descrizione;
    /**
     * The DescrizioneCausa
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DescrizioneCausa;
    /**
     * The Durata
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Durata;
    /**
     * The Esercizio
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Esercizio;
    /**
     * The EvidenziaMinorenni
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $EvidenziaMinorenni;
    /**
     * The IDAssegnazione
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $IDAssegnazione;
    /**
     * The IDCausa
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $IDCausa;
    /**
     * The IDSezione
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $IDSezione;
    /**
     * The Mezzo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Mezzo
     */
    public $Mezzo;
    /**
     * The MostraQualifiche
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $MostraQualifiche;
    /**
     * The NumMaxPersonale
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $NumMaxPersonale;
    /**
     * The NumMinPersonale
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $NumMinPersonale;
    /**
     * The Numero
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $Numero;
    /**
     * The NumeroRiga
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $NumeroRiga;
    /**
     * The OraInizio
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $OraInizio;
    /**
     * The Registro
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Registro;
    /**
     * Constructor method for Evento
     * @uses Evento::setAnnotazioni()
     * @uses Evento::setAttivita()
     * @uses Evento::setCancellabile()
     * @uses Evento::setCancellabileOre()
     * @uses Evento::setDescrizione()
     * @uses Evento::setDescrizioneCausa()
     * @uses Evento::setDurata()
     * @uses Evento::setEsercizio()
     * @uses Evento::setEvidenziaMinorenni()
     * @uses Evento::setIDAssegnazione()
     * @uses Evento::setIDCausa()
     * @uses Evento::setIDSezione()
     * @uses Evento::setMezzo()
     * @uses Evento::setMostraQualifiche()
     * @uses Evento::setNumMaxPersonale()
     * @uses Evento::setNumMinPersonale()
     * @uses Evento::setNumero()
     * @uses Evento::setNumeroRiga()
     * @uses Evento::setOraInizio()
     * @uses Evento::setRegistro()
     * @param string $annotazioni
     * @param \ArrayType\ArrayOfEAttivita $attivita
     * @param bool $cancellabile
     * @param int $cancellabileOre
     * @param string $descrizione
     * @param string $descrizioneCausa
     * @param string $durata
     * @param string $esercizio
     * @param bool $evidenziaMinorenni
     * @param string $iDAssegnazione
     * @param string $iDCausa
     * @param string $iDSezione
     * @param \StructType\Mezzo $mezzo
     * @param bool $mostraQualifiche
     * @param int $numMaxPersonale
     * @param int $numMinPersonale
     * @param int $numero
     * @param int $numeroRiga
     * @param string $oraInizio
     * @param string $registro
     */
    public function __construct($annotazioni = null, \ArrayType\ArrayOfEAttivita $attivita = null, $cancellabile = null, $cancellabileOre = null, $descrizione = null, $descrizioneCausa = null, $durata = null, $esercizio = null, $evidenziaMinorenni = null, $iDAssegnazione = null, $iDCausa = null, $iDSezione = null, \StructType\Mezzo $mezzo = null, $mostraQualifiche = null, $numMaxPersonale = null, $numMinPersonale = null, $numero = null, $numeroRiga = null, $oraInizio = null, $registro = null)
    {
        $this
            ->setAnnotazioni($annotazioni)
            ->setAttivita($attivita)
            ->setCancellabile($cancellabile)
            ->setCancellabileOre($cancellabileOre)
            ->setDescrizione($descrizione)
            ->setDescrizioneCausa($descrizioneCausa)
            ->setDurata($durata)
            ->setEsercizio($esercizio)
            ->setEvidenziaMinorenni($evidenziaMinorenni)
            ->setIDAssegnazione($iDAssegnazione)
            ->setIDCausa($iDCausa)
            ->setIDSezione($iDSezione)
            ->setMezzo($mezzo)
            ->setMostraQualifiche($mostraQualifiche)
            ->setNumMaxPersonale($numMaxPersonale)
            ->setNumMinPersonale($numMinPersonale)
            ->setNumero($numero)
            ->setNumeroRiga($numeroRiga)
            ->setOraInizio($oraInizio)
            ->setRegistro($registro);
    }
    /**
     * Get Annotazioni value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAnnotazioni()
    {
        return isset($this->Annotazioni) ? $this->Annotazioni : null;
    }
    /**
     * Set Annotazioni value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $annotazioni
     * @return \StructType\Evento
     */
    public function setAnnotazioni($annotazioni = null)
    {
        // validation for constraint: string
        if (!is_null($annotazioni) && !is_string($annotazioni)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($annotazioni, true), gettype($annotazioni)), __LINE__);
        }
        if (is_null($annotazioni) || (is_array($annotazioni) && empty($annotazioni))) {
            unset($this->Annotazioni);
        } else {
            $this->Annotazioni = $annotazioni;
        }
        return $this;
    }
    /**
     * Get Attivita value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfEAttivita|null
     */
    public function getAttivita()
    {
        return isset($this->Attivita) ? $this->Attivita : null;
    }
    /**
     * Set Attivita value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfEAttivita $attivita
     * @return \StructType\Evento
     */
    public function setAttivita(\ArrayType\ArrayOfEAttivita $attivita = null)
    {
        if (is_null($attivita) || (is_array($attivita) && empty($attivita))) {
            unset($this->Attivita);
        } else {
            $this->Attivita = $attivita;
        }
        return $this;
    }
    /**
     * Get Cancellabile value
     * @return bool|null
     */
    public function getCancellabile()
    {
        return $this->Cancellabile;
    }
    /**
     * Set Cancellabile value
     * @param bool $cancellabile
     * @return \StructType\Evento
     */
    public function setCancellabile($cancellabile = null)
    {
        // validation for constraint: boolean
        if (!is_null($cancellabile) && !is_bool($cancellabile)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($cancellabile, true), gettype($cancellabile)), __LINE__);
        }
        $this->Cancellabile = $cancellabile;
        return $this;
    }
    /**
     * Get CancellabileOre value
     * @return int|null
     */
    public function getCancellabileOre()
    {
        return $this->CancellabileOre;
    }
    /**
     * Set CancellabileOre value
     * @param int $cancellabileOre
     * @return \StructType\Evento
     */
    public function setCancellabileOre($cancellabileOre = null)
    {
        // validation for constraint: int
        if (!is_null($cancellabileOre) && !(is_int($cancellabileOre) || ctype_digit($cancellabileOre))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($cancellabileOre, true), gettype($cancellabileOre)), __LINE__);
        }
        $this->CancellabileOre = $cancellabileOre;
        return $this;
    }
    /**
     * Get Descrizione value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDescrizione()
    {
        return isset($this->Descrizione) ? $this->Descrizione : null;
    }
    /**
     * Set Descrizione value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $descrizione
     * @return \StructType\Evento
     */
    public function setDescrizione($descrizione = null)
    {
        // validation for constraint: string
        if (!is_null($descrizione) && !is_string($descrizione)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($descrizione, true), gettype($descrizione)), __LINE__);
        }
        if (is_null($descrizione) || (is_array($descrizione) && empty($descrizione))) {
            unset($this->Descrizione);
        } else {
            $this->Descrizione = $descrizione;
        }
        return $this;
    }
    /**
     * Get DescrizioneCausa value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDescrizioneCausa()
    {
        return isset($this->DescrizioneCausa) ? $this->DescrizioneCausa : null;
    }
    /**
     * Set DescrizioneCausa value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $descrizioneCausa
     * @return \StructType\Evento
     */
    public function setDescrizioneCausa($descrizioneCausa = null)
    {
        // validation for constraint: string
        if (!is_null($descrizioneCausa) && !is_string($descrizioneCausa)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($descrizioneCausa, true), gettype($descrizioneCausa)), __LINE__);
        }
        if (is_null($descrizioneCausa) || (is_array($descrizioneCausa) && empty($descrizioneCausa))) {
            unset($this->DescrizioneCausa);
        } else {
            $this->DescrizioneCausa = $descrizioneCausa;
        }
        return $this;
    }
    /**
     * Get Durata value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDurata()
    {
        return isset($this->Durata) ? $this->Durata : null;
    }
    /**
     * Set Durata value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $durata
     * @return \StructType\Evento
     */
    public function setDurata($durata = null)
    {
        // validation for constraint: string
        if (!is_null($durata) && !is_string($durata)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($durata, true), gettype($durata)), __LINE__);
        }
        if (is_null($durata) || (is_array($durata) && empty($durata))) {
            unset($this->Durata);
        } else {
            $this->Durata = $durata;
        }
        return $this;
    }
    /**
     * Get Esercizio value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getEsercizio()
    {
        return isset($this->Esercizio) ? $this->Esercizio : null;
    }
    /**
     * Set Esercizio value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $esercizio
     * @return \StructType\Evento
     */
    public function setEsercizio($esercizio = null)
    {
        // validation for constraint: string
        if (!is_null($esercizio) && !is_string($esercizio)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($esercizio, true), gettype($esercizio)), __LINE__);
        }
        if (is_null($esercizio) || (is_array($esercizio) && empty($esercizio))) {
            unset($this->Esercizio);
        } else {
            $this->Esercizio = $esercizio;
        }
        return $this;
    }
    /**
     * Get EvidenziaMinorenni value
     * @return bool|null
     */
    public function getEvidenziaMinorenni()
    {
        return $this->EvidenziaMinorenni;
    }
    /**
     * Set EvidenziaMinorenni value
     * @param bool $evidenziaMinorenni
     * @return \StructType\Evento
     */
    public function setEvidenziaMinorenni($evidenziaMinorenni = null)
    {
        // validation for constraint: boolean
        if (!is_null($evidenziaMinorenni) && !is_bool($evidenziaMinorenni)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($evidenziaMinorenni, true), gettype($evidenziaMinorenni)), __LINE__);
        }
        $this->EvidenziaMinorenni = $evidenziaMinorenni;
        return $this;
    }
    /**
     * Get IDAssegnazione value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getIDAssegnazione()
    {
        return isset($this->IDAssegnazione) ? $this->IDAssegnazione : null;
    }
    /**
     * Set IDAssegnazione value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $iDAssegnazione
     * @return \StructType\Evento
     */
    public function setIDAssegnazione($iDAssegnazione = null)
    {
        // validation for constraint: string
        if (!is_null($iDAssegnazione) && !is_string($iDAssegnazione)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($iDAssegnazione, true), gettype($iDAssegnazione)), __LINE__);
        }
        if (is_null($iDAssegnazione) || (is_array($iDAssegnazione) && empty($iDAssegnazione))) {
            unset($this->IDAssegnazione);
        } else {
            $this->IDAssegnazione = $iDAssegnazione;
        }
        return $this;
    }
    /**
     * Get IDCausa value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getIDCausa()
    {
        return isset($this->IDCausa) ? $this->IDCausa : null;
    }
    /**
     * Set IDCausa value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $iDCausa
     * @return \StructType\Evento
     */
    public function setIDCausa($iDCausa = null)
    {
        // validation for constraint: string
        if (!is_null($iDCausa) && !is_string($iDCausa)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($iDCausa, true), gettype($iDCausa)), __LINE__);
        }
        if (is_null($iDCausa) || (is_array($iDCausa) && empty($iDCausa))) {
            unset($this->IDCausa);
        } else {
            $this->IDCausa = $iDCausa;
        }
        return $this;
    }
    /**
     * Get IDSezione value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getIDSezione()
    {
        return isset($this->IDSezione) ? $this->IDSezione : null;
    }
    /**
     * Set IDSezione value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $iDSezione
     * @return \StructType\Evento
     */
    public function setIDSezione($iDSezione = null)
    {
        // validation for constraint: string
        if (!is_null($iDSezione) && !is_string($iDSezione)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($iDSezione, true), gettype($iDSezione)), __LINE__);
        }
        if (is_null($iDSezione) || (is_array($iDSezione) && empty($iDSezione))) {
            unset($this->IDSezione);
        } else {
            $this->IDSezione = $iDSezione;
        }
        return $this;
    }
    /**
     * Get Mezzo value
     * @return \StructType\Mezzo|null
     */
    public function getMezzo()
    {
        return $this->Mezzo;
    }
    /**
     * Set Mezzo value
     * @param \StructType\Mezzo $mezzo
     * @return \StructType\Evento
     */
    public function setMezzo(\StructType\Mezzo $mezzo = null)
    {
        $this->Mezzo = $mezzo;
        return $this;
    }
    /**
     * Get MostraQualifiche value
     * @return bool|null
     */
    public function getMostraQualifiche()
    {
        return $this->MostraQualifiche;
    }
    /**
     * Set MostraQualifiche value
     * @param bool $mostraQualifiche
     * @return \StructType\Evento
     */
    public function setMostraQualifiche($mostraQualifiche = null)
    {
        // validation for constraint: boolean
        if (!is_null($mostraQualifiche) && !is_bool($mostraQualifiche)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($mostraQualifiche, true), gettype($mostraQualifiche)), __LINE__);
        }
        $this->MostraQualifiche = $mostraQualifiche;
        return $this;
    }
    /**
     * Get NumMaxPersonale value
     * @return int|null
     */
    public function getNumMaxPersonale()
    {
        return $this->NumMaxPersonale;
    }
    /**
     * Set NumMaxPersonale value
     * @param int $numMaxPersonale
     * @return \StructType\Evento
     */
    public function setNumMaxPersonale($numMaxPersonale = null)
    {
        // validation for constraint: int
        if (!is_null($numMaxPersonale) && !(is_int($numMaxPersonale) || ctype_digit($numMaxPersonale))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($numMaxPersonale, true), gettype($numMaxPersonale)), __LINE__);
        }
        $this->NumMaxPersonale = $numMaxPersonale;
        return $this;
    }
    /**
     * Get NumMinPersonale value
     * @return int|null
     */
    public function getNumMinPersonale()
    {
        return $this->NumMinPersonale;
    }
    /**
     * Set NumMinPersonale value
     * @param int $numMinPersonale
     * @return \StructType\Evento
     */
    public function setNumMinPersonale($numMinPersonale = null)
    {
        // validation for constraint: int
        if (!is_null($numMinPersonale) && !(is_int($numMinPersonale) || ctype_digit($numMinPersonale))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($numMinPersonale, true), gettype($numMinPersonale)), __LINE__);
        }
        $this->NumMinPersonale = $numMinPersonale;
        return $this;
    }
    /**
     * Get Numero value
     * @return int|null
     */
    public function getNumero()
    {
        return $this->Numero;
    }
    /**
     * Set Numero value
     * @param int $numero
     * @return \StructType\Evento
     */
    public function setNumero($numero = null)
    {
        // validation for constraint: int
        if (!is_null($numero) && !(is_int($numero) || ctype_digit($numero))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($numero, true), gettype($numero)), __LINE__);
        }
        $this->Numero = $numero;
        return $this;
    }
    /**
     * Get NumeroRiga value
     * @return int|null
     */
    public function getNumeroRiga()
    {
        return $this->NumeroRiga;
    }
    /**
     * Set NumeroRiga value
     * @param int $numeroRiga
     * @return \StructType\Evento
     */
    public function setNumeroRiga($numeroRiga = null)
    {
        // validation for constraint: int
        if (!is_null($numeroRiga) && !(is_int($numeroRiga) || ctype_digit($numeroRiga))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($numeroRiga, true), gettype($numeroRiga)), __LINE__);
        }
        $this->NumeroRiga = $numeroRiga;
        return $this;
    }
    /**
     * Get OraInizio value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getOraInizio()
    {
        return isset($this->OraInizio) ? $this->OraInizio : null;
    }
    /**
     * Set OraInizio value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $oraInizio
     * @return \StructType\Evento
     */
    public function setOraInizio($oraInizio = null)
    {
        // validation for constraint: string
        if (!is_null($oraInizio) && !is_string($oraInizio)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($oraInizio, true), gettype($oraInizio)), __LINE__);
        }
        if (is_null($oraInizio) || (is_array($oraInizio) && empty($oraInizio))) {
            unset($this->OraInizio);
        } else {
            $this->OraInizio = $oraInizio;
        }
        return $this;
    }
    /**
     * Get Registro value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRegistro()
    {
        return isset($this->Registro) ? $this->Registro : null;
    }
    /**
     * Set Registro value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $registro
     * @return \StructType\Evento
     */
    public function setRegistro($registro = null)
    {
        // validation for constraint: string
        if (!is_null($registro) && !is_string($registro)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($registro, true), gettype($registro)), __LINE__);
        }
        if (is_null($registro) || (is_array($registro) && empty($registro))) {
            unset($this->Registro);
        } else {
            $this->Registro = $registro;
        }
        return $this;
    }
}
