<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PresenzaModel StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:PresenzaModel
 * @subpackage Structs
 */
class PresenzaModel extends AbstractStructBase
{
    /**
     * The Attivita
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AttivitaModel
     */
    public $Attivita;
    /**
     * The Causale
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Causale;
    /**
     * The Data
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Data;
    /**
     * The ID
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $ID;
    /**
     * The Ora
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Ora;
    /**
     * The Sezione
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Sezione_Model
     */
    public $Sezione;
    /**
     * The Utente
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\UtentePCGav
     */
    public $Utente;
    /**
     * Constructor method for PresenzaModel
     * @uses PresenzaModel::setAttivita()
     * @uses PresenzaModel::setCausale()
     * @uses PresenzaModel::setData()
     * @uses PresenzaModel::setID()
     * @uses PresenzaModel::setOra()
     * @uses PresenzaModel::setSezione()
     * @uses PresenzaModel::setUtente()
     * @param \StructType\AttivitaModel $attivita
     * @param string $causale
     * @param string $data
     * @param int $iD
     * @param string $ora
     * @param \StructType\Sezione_Model $sezione
     * @param \StructType\UtentePCGav $utente
     */
    public function __construct(\StructType\AttivitaModel $attivita = null, $causale = null, $data = null, $iD = null, $ora = null, \StructType\Sezione_Model $sezione = null, \StructType\UtentePCGav $utente = null)
    {
        $this
            ->setAttivita($attivita)
            ->setCausale($causale)
            ->setData($data)
            ->setID($iD)
            ->setOra($ora)
            ->setSezione($sezione)
            ->setUtente($utente);
    }
    /**
     * Get Attivita value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AttivitaModel|null
     */
    public function getAttivita()
    {
        return isset($this->Attivita) ? $this->Attivita : null;
    }
    /**
     * Set Attivita value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\AttivitaModel $attivita
     * @return \StructType\PresenzaModel
     */
    public function setAttivita(\StructType\AttivitaModel $attivita = null)
    {
        if (is_null($attivita) || (is_array($attivita) && empty($attivita))) {
            unset($this->Attivita);
        } else {
            $this->Attivita = $attivita;
        }
        return $this;
    }
    /**
     * Get Causale value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCausale()
    {
        return isset($this->Causale) ? $this->Causale : null;
    }
    /**
     * Set Causale value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $causale
     * @return \StructType\PresenzaModel
     */
    public function setCausale($causale = null)
    {
        // validation for constraint: string
        if (!is_null($causale) && !is_string($causale)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($causale, true), gettype($causale)), __LINE__);
        }
        if (is_null($causale) || (is_array($causale) && empty($causale))) {
            unset($this->Causale);
        } else {
            $this->Causale = $causale;
        }
        return $this;
    }
    /**
     * Get Data value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getData()
    {
        return isset($this->Data) ? $this->Data : null;
    }
    /**
     * Set Data value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $data
     * @return \StructType\PresenzaModel
     */
    public function setData($data = null)
    {
        // validation for constraint: string
        if (!is_null($data) && !is_string($data)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($data, true), gettype($data)), __LINE__);
        }
        if (is_null($data) || (is_array($data) && empty($data))) {
            unset($this->Data);
        } else {
            $this->Data = $data;
        }
        return $this;
    }
    /**
     * Get ID value
     * @return int|null
     */
    public function getID()
    {
        return $this->ID;
    }
    /**
     * Set ID value
     * @param int $iD
     * @return \StructType\PresenzaModel
     */
    public function setID($iD = null)
    {
        // validation for constraint: int
        if (!is_null($iD) && !(is_int($iD) || ctype_digit($iD))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($iD, true), gettype($iD)), __LINE__);
        }
        $this->ID = $iD;
        return $this;
    }
    /**
     * Get Ora value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getOra()
    {
        return isset($this->Ora) ? $this->Ora : null;
    }
    /**
     * Set Ora value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $ora
     * @return \StructType\PresenzaModel
     */
    public function setOra($ora = null)
    {
        // validation for constraint: string
        if (!is_null($ora) && !is_string($ora)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ora, true), gettype($ora)), __LINE__);
        }
        if (is_null($ora) || (is_array($ora) && empty($ora))) {
            unset($this->Ora);
        } else {
            $this->Ora = $ora;
        }
        return $this;
    }
    /**
     * Get Sezione value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Sezione_Model|null
     */
    public function getSezione()
    {
        return isset($this->Sezione) ? $this->Sezione : null;
    }
    /**
     * Set Sezione value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Sezione_Model $sezione
     * @return \StructType\PresenzaModel
     */
    public function setSezione(\StructType\Sezione_Model $sezione = null)
    {
        if (is_null($sezione) || (is_array($sezione) && empty($sezione))) {
            unset($this->Sezione);
        } else {
            $this->Sezione = $sezione;
        }
        return $this;
    }
    /**
     * Get Utente value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\UtentePCGav|null
     */
    public function getUtente()
    {
        return isset($this->Utente) ? $this->Utente : null;
    }
    /**
     * Set Utente value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\UtentePCGav $utente
     * @return \StructType\PresenzaModel
     */
    public function setUtente(\StructType\UtentePCGav $utente = null)
    {
        if (is_null($utente) || (is_array($utente) && empty($utente))) {
            unset($this->Utente);
        } else {
            $this->Utente = $utente;
        }
        return $this;
    }
}
